=== modified file 'NEWS'
--- NEWS	2009-05-11 20:01:13 +0000
+++ NEWS	2009-05-12 03:47:18 +0000
@@ -137,7 +137,12 @@
   called before the first test is started, ``done`` called after the last
   test completes, and a new parameter ``strict``. (Robert Collins)
 
-* -Dlock when passed to the selftest (e.g. ``bzr -Dlock selftest``) will
+* ``-Dhpss`` when passed to bzr will cause a backtrace to be printed when
+  VFS operations are started on a smart server repository. This should not
+  occur on regular push and pull operations, and is a key indicator for
+  performance regressions. (Robert Collins)
+
+* ``-Dlock`` when passed to the selftest (e.g. ``bzr -Dlock selftest``) will
   cause mismatched physical locks to cause test errors rather than just
   reporting to the screen. (Robert Collins)
 

=== modified file 'bzrlib/remote.py'
--- bzrlib/remote.py	2009-04-28 06:53:29 +0000
+++ bzrlib/remote.py	2009-05-10 23:45:33 +0000
@@ -688,6 +688,10 @@
         invocation. If in doubt chat to the bzr network team.
         """
         if self._real_repository is None:
+            if 'hpss' in debug.debug_flags:
+                import traceback
+                warning('VFS Repository access triggered\n%s',
+                    ''.join(traceback.format_stack()))
             self._unstacked_provider.missing_keys.clear()
             self.bzrdir._ensure_real()
             self._set_real_repository(

